﻿module.exports = new (function () {
    var self = this;
    this.delHtmlTag = function (str) {
        return str.replace(/<[^>]+>/g, "");
    };
    this.htmlEncode = function (text) {
        return text.replace && text.replace(/&/g, '&amp;').replace(/\"/g, '&quot;').replace(/</g, '&lt;').replace(/>/g, '&gt;') || text;
    };
    this.htmlDecode = function (text) {
        return text.replace && text.replace(/&amp;/g, '&').replace(/&quot;/g, '\"').replace(/&lt;/g, '<').replace(/&gt;/g, '>') || text;
    };
    this.htmlImgFilter = function (html) {
        var reg = /<img.+?src=('|")?([^'"]+)('|")?(?:\s+|>)/gim;
        var arr = [];
        var tem;
        while ((tem = reg.exec(html))) {
            arr.push(tem[2]);
        }
        return arr;
    };
    this.urlsearch = function (name, location) {
        var url = location;
        var i = url.indexOf('?') || 0;
        var reg = new RegExp("(^|&)" + name + "=([^&]*)(&|$)", "i");
        var r = url.substr(i + 1).match(reg);
        if (r != null) return decodeURI(r[2]);
        return "";
    };
    this.dateFormat = function (date, format) {
        date = new Date(date);
        var map = {
            "M": date.getMonth() + 1, //月份   
            "d": date.getDate(), //日   
            "h": date.getHours(), //小时   
            "m": date.getMinutes(), //分   
            "s": date.getSeconds(), //秒   
            "q": Math.floor((date.getMonth() + 3) / 3) //季度 
        };
        format = format.replace(/([yMdhmsqf])+/g, function (all, t) {
            var v = map[t];
            if (v !== undefined) {
                if (all.length > 1) {
                    v = '0' + v;
                    v = v.substr(v.length - 2);
                }
                return v;
            } else if (t === 'y') {
                return (date.getFullYear() + '').substr(4 - all.length);
            } else if (t === 'f') {
                return (date.getMilliseconds() + '').substr(3 - all.length);
            }
            return all;
        });
        return format;
    };
    this.getTimeNow = function () {
        return this.dateFormat(new Date(), 'yyyy-MM-d h:m:s');
    };
    this.GetTimeDate = function () {
        return this.dateFormat(new Date(), 'yyyy-MM-dd');
    };
    this.formatTime = function (t) {
        if (t) {
            if (typeof t === "object") {
                return t;
            } else if (typeof t === "number") {
                return new Date(t);
            } else if (typeof t === "string") {
                if (!t.length || t.length < 5) return '';
                return new Date(t.replace(/-/g, "/"));
            }
        }
        return '';
    };
    this.formatTimeNow = function (tobj) {
        var ttime = self.formatTime(tobj);
        var now = new Date();
        function name(h) {
            if (h < 6) return '凌晨';
            else if (h < 12) return '上午';
            else if (h < 20) return '下午';
            return '晚上';
        }
        function hname(h) {
            var ht = parseInt((now.getTime() - h.getTime()) / 1000);
            return ht < 60 ? ht + '秒以前' : parseInt(ht / 60) + '分钟以前';
        }
        var html;
        if (now.getFullYear() !== ttime.getFullYear()) {
            html = ttime.getFullYear() + '-' + (ttime.getMonth() + 1) + '-' + ttime.getDate() + ' ' + ttime.getHours();
        } else if (now.getTime() - ttime.getTime() > 172800000) {
            html = (ttime.getMonth() + 1) + '-' + ttime.getDate() + ' ' + ttime.getHours();
        } else if (now.getMonth() === ttime.getMonth() && (now.getDate() - ttime.getDate() === 1) || (now.getMonth() - ttime.getMonth() === 1) && now.getDate() === 1) {
            html = "昨天 " + name(ttime.getHours()) + ttime.getHours();
        } else if (now.getMonth() === ttime.getMonth() && now.getDate() === ttime.getDate()) {
            if (now.getTime() - ttime.getTime() > 3600000) {
                html = "今天 " + name(ttime.getHours()) + ttime.getHours();
            } else {
                return hname(ttime);
            }

        } else {
            html = (ttime.getMonth() + 1) + '-' + ttime.getDate() + ' ' + name(ttime.getHours()) + ttime.getHours();
        }
        html += ':' + ttime.getMinutes();
        return html;
    };
    this.restTime = function (tobj) {
        var ttime = self.formatTime(tobj);
        var now = new Date();
        if (ttime.getTime() > now.getTime())
            return self.dateFormat(ttime.getTime() > now.getTime(), 'MM-d h:m:s');
        return this.dateFormat(tobj, 'yyyy-MM-d h:m:s');
    };
    this.timecompare = function (t1, t2) {
        if (!t1) return -1;
        if (!t2) return 1;
        t1 = self.formatTime(t1);
        t2 = self.formatTime(t2);
        return t1.getTime() > t2.getTime();
    };
    this.getRandom = function (min, max) {
        var range = max - min;
        var rand = Math.random();
        return (min + Math.round(rand * range));
    };
    this.requestQueryString = function (url, name) {
        var i = url.indexOf('?') || 0;
        var reg = new RegExp("(^|&)" + name + "=([^&]*)(&|$)", "i");
        var r = url.substr(i + 1).match(reg);
        if (r != null) return unescape(r[2]);
        return "";
    };
    this.guid = function () {
        function s4() {
            return (((1 + Math.random()) * 0x10000) | 0).toString(16).substring(1);
        }

        return (s4() + s4() + s4() + s4() + s4() + s4() + s4() + s4());
    };
    this.distance = function (lat1, lng1, lat2, lng2) {
        function rad(d) {
            return d * Math.PI / 180.0;
        }
        var radLat1 = rad(lat1);
        var radLat2 = rad(lat2);
        var a = radLat1 - radLat2;
        var b = rad(lng1) - rad(lng2);

        var s = 2 * Math.asin(Math.sqrt(Math.pow(Math.sin(a / 2), 2)
            + Math.cos(radLat1) * Math.cos(radLat2)
            * Math.pow(Math.sin(b / 2), 2)));
        s = s * 6378.137;
        s = Math.round(s * 1000);
        return s;
    }
    this.getext = function (filename) {
        return filename.substring(filename.lastIndexOf('.'), filename.length);
    };
    this.inherit = function (child, base) {
        for (var key in base) {
            if (base.hasOwnProperty(key) && !child[key]) {
                child[key] = base[key];
            }
        }
    };
    this.getRandom = function (min, max) {
        var Range = max - min;
        var Rand = Math.random();
        return (min + Math.round(Rand * Range));
    };
    this.getClientIp = function (req) {
        var ip = (req.headers['x-forwarded-for'] ||
            req.connection.remoteAddress ||
            req.socket.remoteAddress ||
            req.connection.socket && req.connection.socket.remoteAddress).replace('::ffff:', '');
        ip = ip.replace('127.0.0.1', '').split(',');
        for (var i = 0; i < ip.length; i++) {
            if (ip[i]) return ip[i].replace(/ /g, '');
        }
        return ip[ip.length - 1].replace(/ /g, '');
    };
    this.jsonfilter = function (value) {
        if (value && value.indexOf('"{"') > -1) {
            while (value.indexOf('"{"') > -1) {
                value = value.replace(/"{"/g, '{"').replace(/}"/g, '}');
            }
            while (value.indexOf('}"') > -1) {
                value = value.replace(/"{"/g, '{"').replace(/}"/g, '}');
            }
        }
        return value;
    };
    this.md5 = function (content) {
        var crypto = require('crypto');
        var md5 = crypto.createHash('md5');
        md5.update(content);
        return md5.digest('hex');
    };
    this.aesEncrypt = function (data, secretKey) {
        try {
            var crypto = require('crypto');
            var cipher = crypto.createCipher('aes-128-ecb', secretKey);
            return cipher.update(data, 'utf8', 'hex') + cipher.final('hex');
        } catch (e) {
            return '';
        }

    };
    this.aesDecrypt = function (data, secretKey) {
        try {
            var crypto = require('crypto');
            var decipher = crypto.createDecipher('aes-128-ecb', secretKey);
            return decipher.update(data, 'hex', 'utf8') + decipher.final('utf8');
        } catch (e) {
            return '';
        }
    };
    this.pageParam = function (e) {
        var pageindex = parseInt(e.PageIndex || 0);
        var pagesize = parseInt(e.PageSize || 20);
        pageindex = pageindex >= 0 ? pageindex : 0;
        pagesize = pagesize > 0 ? pagesize : 20;
        var start = pageindex * pagesize;
        var size = pagesize;
        return {
            pageindex: pageindex,
            pagesize: pagesize,
            pageall: 1,
            start: start,
            size: size
        };
    };

    Date.prototype.addYear = function (y) {
        return new Date((this.getFullYear() + y) + '-' + (this.getMonth() + 1) + '-' + this.getDate() + ' ' + this.getHours() + ':' + this.getMinutes() + ':' + this.getSeconds());
    };
    Date.prototype.addMonth = function (m) {
        var m1 = this.getMonth() + m + 1;
        var y = parseInt(m1 / 12);
        m1 = m1 % 12;
        return new Date((this.getFullYear() + y) + '-' + (m1) + '-' + this.getDate() + ' ' + this.getHours() + ':' + this.getMinutes() + ':' + this.getSeconds());
    };
    Date.prototype.addDay = function (d) {
        return new Date(this.getTime() + d * 24 * 60 * 60000);
    };

    String.prototype.Trim = function () {
        return this.replace(/(^\s*)|(\s*$)/g, "");
    }
    String.prototype.LTrim = function () {
        return this.replace(/(^\s*)/g, "");
    }
    String.prototype.RTrim = function () {
        return this.replace(/(\s*$)/g, "");
    }
    String.prototype.format = function (args) {
        var result = this;
        if (arguments.length > 0) {
            if (arguments.length == 1 && typeof (args) == "object") {
                for (var key in args) {
                    if (args[key] != undefined) {
                        var reg = new RegExp("({" + key + "})", "g");
                        result = result.replace(reg, args[key]);
                    }
                }
            }
            else {
                for (var i = 0; i < arguments.length; i++) {
                    if (arguments[i] != undefined) {
                        var reg = new RegExp("({[" + i + "]})", "g");
                        result = result.replace(reg, arguments[i]);
                    }
                }
            }
        }
        return result;
    }
    Date.prototype.format = function (args) {
        return self.dateFormat(this, args);
    }
})();
